#include "STC8G.h"
#include "intrins.h"

bit isda = 1;
bit isma = 1;
unsigned char rx = 0;

void I2C_Isr() interrupt 24
{
	_push_(P_SW2);
	P_SW2 |= 0x80;
	
	if(I2CSLST & 0x40)
	{
		I2CSLST &= ~0x40;
	}
	else if(I2CSLST & 0x20)
	{
		I2CSLST &= ~0x20;
		if(isda)
		{
			isda = 0;
		}
		else if(isma)
		{
			isma = 0;
			rx = I2CRXD;
			I2CTXD = (rx + 1);
		}
	}
	else if(I2CSLST & 0x10)
	{
		I2CSLST &= ~0x10;
	}
	else if(I2CSLST & 0x08)
	{
		I2CSLST &= ~0x08;
		isda = 1;
		isma = 1;
	}
	
	_pop_(P_SW2);
}

void main()
{
	P0M0 = 0x00;
  P0M1 = 0x00;
  P1M0 = 0x00;
  P1M1 = 0x00;
  P2M0 = 0x00;
  P2M1 = 0x00;
  P3M0 = 0x00;
  P3M1 = 0x00;
  P4M0 = 0x00;
  P4M1 = 0x00;
  P5M0 = 0x00;
  P5M1 = 0x00;
	
	P_SW2 = 0x30;
	I2CCFG = 0x81;
	I2CSLADR = 0x5a;
	I2CSLST = 0x00;
	I2CSLCR = 0x78;
	EA = 1;
	isda = 1;
	isma = 1;
	
	while(1) {}
}